/**
 */
package tools.descartes.prisma.agent.generic.genericagent;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.prisma.agent.generic.genericagent.GenericAgentFactory
 * @model kind="package"
 * @generated
 */
public interface GenericAgentPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "genericagent";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://descartes.tools/prisma/genericagent/0.1";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "genericagent";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	GenericAgentPackage eINSTANCE = tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentPackageImpl.init();

	/**
	 * The meta object id for the '{@link tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentConfigurationImpl <em>Configuration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentConfigurationImpl
	 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentPackageImpl#getGenericAgentConfiguration()
	 * @generated
	 */
	int GENERIC_AGENT_CONFIGURATION = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_AGENT_CONFIGURATION__ID = 0;

	/**
	 * The feature id for the '<em><b>Scope</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_AGENT_CONFIGURATION__SCOPE = 1;

	/**
	 * The feature id for the '<em><b>Delegated Objects</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_AGENT_CONFIGURATION__DELEGATED_OBJECTS = 2;

	/**
	 * The feature id for the '<em><b>Required Objects</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_AGENT_CONFIGURATION__REQUIRED_OBJECTS = 3;

	/**
	 * The feature id for the '<em><b>Skeleton</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_AGENT_CONFIGURATION__SKELETON = 4;

	/**
	 * The number of structural features of the '<em>Configuration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_AGENT_CONFIGURATION_FEATURE_COUNT = 5;

	/**
	 * The number of operations of the '<em>Configuration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_AGENT_CONFIGURATION_OPERATION_COUNT = 0;


	/**
	 * The meta object id for the '{@link tools.descartes.prisma.agent.generic.genericagent.impl.RequiredObjectImpl <em>Required Object</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.prisma.agent.generic.genericagent.impl.RequiredObjectImpl
	 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentPackageImpl#getRequiredObject()
	 * @generated
	 */
	int REQUIRED_OBJECT = 1;

	/**
	 * The feature id for the '<em><b>Object</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRED_OBJECT__OBJECT = 0;

	/**
	 * The number of structural features of the '<em>Required Object</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRED_OBJECT_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Required Object</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRED_OBJECT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.prisma.agent.generic.genericagent.impl.RequiredContainerImpl <em>Required Container</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.prisma.agent.generic.genericagent.impl.RequiredContainerImpl
	 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentPackageImpl#getRequiredContainer()
	 * @generated
	 */
	int REQUIRED_CONTAINER = 2;

	/**
	 * The feature id for the '<em><b>Object</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRED_CONTAINER__OBJECT = REQUIRED_OBJECT__OBJECT;

	/**
	 * The feature id for the '<em><b>Container</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRED_CONTAINER__CONTAINER = REQUIRED_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Required Container</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRED_CONTAINER_FEATURE_COUNT = REQUIRED_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Required Container</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRED_CONTAINER_OPERATION_COUNT = REQUIRED_OBJECT_OPERATION_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration <em>Configuration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Configuration</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration
	 * @generated
	 */
	EClass getGenericAgentConfiguration();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getId()
	 * @see #getGenericAgentConfiguration()
	 * @generated
	 */
	EAttribute getGenericAgentConfiguration_Id();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getScope <em>Scope</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Scope</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getScope()
	 * @see #getGenericAgentConfiguration()
	 * @generated
	 */
	EReference getGenericAgentConfiguration_Scope();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getDelegatedObjects <em>Delegated Objects</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Delegated Objects</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getDelegatedObjects()
	 * @see #getGenericAgentConfiguration()
	 * @generated
	 */
	EReference getGenericAgentConfiguration_DelegatedObjects();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getRequiredObjects <em>Required Objects</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Required Objects</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getRequiredObjects()
	 * @see #getGenericAgentConfiguration()
	 * @generated
	 */
	EReference getGenericAgentConfiguration_RequiredObjects();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getSkeleton <em>Skeleton</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Skeleton</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getSkeleton()
	 * @see #getGenericAgentConfiguration()
	 * @generated
	 */
	EReference getGenericAgentConfiguration_Skeleton();

	/**
	 * Returns the meta object for class '{@link tools.descartes.prisma.agent.generic.genericagent.RequiredObject <em>Required Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Required Object</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.RequiredObject
	 * @generated
	 */
	EClass getRequiredObject();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.prisma.agent.generic.genericagent.RequiredObject#getObject <em>Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Object</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.RequiredObject#getObject()
	 * @see #getRequiredObject()
	 * @generated
	 */
	EReference getRequiredObject_Object();

	/**
	 * Returns the meta object for class '{@link tools.descartes.prisma.agent.generic.genericagent.RequiredContainer <em>Required Container</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Required Container</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.RequiredContainer
	 * @generated
	 */
	EClass getRequiredContainer();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.prisma.agent.generic.genericagent.RequiredContainer#getContainer <em>Container</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Container</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.RequiredContainer#getContainer()
	 * @see #getRequiredContainer()
	 * @generated
	 */
	EReference getRequiredContainer_Container();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	GenericAgentFactory getGenericAgentFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentConfigurationImpl <em>Configuration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentConfigurationImpl
		 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentPackageImpl#getGenericAgentConfiguration()
		 * @generated
		 */
		EClass GENERIC_AGENT_CONFIGURATION = eINSTANCE.getGenericAgentConfiguration();

		/**
		 * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GENERIC_AGENT_CONFIGURATION__ID = eINSTANCE.getGenericAgentConfiguration_Id();

		/**
		 * The meta object literal for the '<em><b>Scope</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERIC_AGENT_CONFIGURATION__SCOPE = eINSTANCE.getGenericAgentConfiguration_Scope();

		/**
		 * The meta object literal for the '<em><b>Delegated Objects</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERIC_AGENT_CONFIGURATION__DELEGATED_OBJECTS = eINSTANCE.getGenericAgentConfiguration_DelegatedObjects();

		/**
		 * The meta object literal for the '<em><b>Required Objects</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERIC_AGENT_CONFIGURATION__REQUIRED_OBJECTS = eINSTANCE.getGenericAgentConfiguration_RequiredObjects();

		/**
		 * The meta object literal for the '<em><b>Skeleton</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERIC_AGENT_CONFIGURATION__SKELETON = eINSTANCE.getGenericAgentConfiguration_Skeleton();

		/**
		 * The meta object literal for the '{@link tools.descartes.prisma.agent.generic.genericagent.impl.RequiredObjectImpl <em>Required Object</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.prisma.agent.generic.genericagent.impl.RequiredObjectImpl
		 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentPackageImpl#getRequiredObject()
		 * @generated
		 */
		EClass REQUIRED_OBJECT = eINSTANCE.getRequiredObject();

		/**
		 * The meta object literal for the '<em><b>Object</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REQUIRED_OBJECT__OBJECT = eINSTANCE.getRequiredObject_Object();

		/**
		 * The meta object literal for the '{@link tools.descartes.prisma.agent.generic.genericagent.impl.RequiredContainerImpl <em>Required Container</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.prisma.agent.generic.genericagent.impl.RequiredContainerImpl
		 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentPackageImpl#getRequiredContainer()
		 * @generated
		 */
		EClass REQUIRED_CONTAINER = eINSTANCE.getRequiredContainer();

		/**
		 * The meta object literal for the '<em><b>Container</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REQUIRED_CONTAINER__CONTAINER = eINSTANCE.getRequiredContainer_Container();

	}

} //GenericAgentPackage
